// =============================================================================
// CARDS (CSS)
// =============================================================================
//
// 1. Allow users to click the anchor tag on the image in the figcaption empty
//    space. This provides a much larger and simpler hit state for navigating
//    to the product details page. (Does not work in IE10 or earlier).
// 2. Using translate3d to counter a chrome specific bug: When using a masonry
//    styled layout via CSS column-count etc, transforms applied to descendants
//    are made invisible, except for 3d transforms...
//
// -----------------------------------------------------------------------------


.card-figure {
    margin-top: $card-figure-marginTop;
    position: relative;
    &:hover {

        // scss-lint:disable NestingDepth
        .card-figcaption {
            opacity: 1;
        }
    }
}

.card-img-container {
    overflow: hidden;
    max-width: get-width(stencilString('productgallery_size'));

    @include lazy-loaded-padding('productgallery_size');
}

.card-figcaption {
    display: none;
    margin: $card-figcaption-margin;
    pointer-events: none; // 1

    @include breakpoint("medium") {
        display: block;
    }
}

.card-figcaption-body {
    display: $card-figcaption-body-display;
    pointer-events: all; // 1
    transform: translate3d(0, -50%, 0); // 2
}

.card-image {
    @include lazy-loaded-img;
    border: 0;
    //width: 100%;
    //max-height: 100%;
    width: auto;
    min-width: 100%;
    min-height: 100%;
    object-fit: cover;
    /* Object-fit polyfill */
    font-family: 'object-fit: cover';
}

.card-title {
    font-size: $card-title-fontSize;
    margin: $card-title-margin;

    > a {
        color: $card-title-color;
        text-decoration: $card-title-textDecoration;

        // scss-lint:disable NestingDepth
        &:hover {
            color: $card-title-color-hover;
        }
    }
}

.card-text {
    margin-bottom: $card-text-marginBottom;

    abbr {
        border: 0;
        text-decoration: none;
        color: inherit;
        font-size: inherit;
    }
}

.card-figcaption-button {
    border: $card-figcaption-button-border;
    display: $card-figcaption-button-display;
    margin: $card-figcaption-button-margin;

    &:active {
        background-color: $card-figcaption-button-backgroundHover;
        border: $card-figcaption-button-border;
    }

    + .card-figcaption-button {
        margin: $card-figcaption-button-margin;
    }
}

.card-body {
    text-align: center;

    @include breakpoint("small") {
        text-align: left;
    }
}


//
// Alternate card
//
// Purpose: Used to give the card alternative styling
// -----------------------------------------------------------------------------

.card--alternate {
    border: 3px solid stencilColor("card--alternate-borderColor");
    transition: all 0.15s ease;

    .card-body {
        background-color: stencilColor("card--alternate-backgroundColor");
        padding: spacing("half");
        transition: all 0.15s ease;

        @include breakpoint("small") {
            padding: spacing("single");
        }
    }

    &:hover {
        border-color: stencilColor("color-primary");

        // scss-lint:disable SelectorDepth, NestingDepth
        .card-body {
            background-color: stencilColor("color-primary");

            .card-text {
                color: stencilColor("card--alternate-color--hover");
            }
        }

        .card-title > a {
            color: stencilColor("card--alternate-color--hover");
        }
    }
}
